package space.eptaproject.vmodaddon.block;

import edn.stratodonut.trackwork.tracks.forces.PhysicsTrackController;
import edn.stratodonut.trackwork.tracks.forces.SimpleWheelController;
import net.minecraft.core.BlockPos;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import org.joml.Vector3d;
import org.joml.Vector3dc;
import org.valkyrienskies.core.api.ships.ServerShip;
import org.valkyrienskies.mod.common.VSGameUtilsKt;
import space.eptaproject.vmodaddon.IPhysicsTrackController;
import space.eptaproject.vmodaddon.ISimpleWheelController;
import space.eptaproject.vmodaddon.Vmodaddon;

public class TBBE extends BlockEntity {
    public TBBE(BlockPos p_155229_, BlockState p_155230_) {
        super(Vmodaddon.MY_BLOCK_ENTITY.get(), p_155229_, p_155230_);
    }

    @Override
    protected void saveAdditional(CompoundTag tag) {
        super.saveAdditional(tag);
        ServerShip ship = (ServerShip) VSGameUtilsKt.getShipObjectManagingPos(this.level, getBlockPos());
        if (ship != null) {
            PhysicsTrackController physicsTrackController = ship.getAttachment(PhysicsTrackController.class);
            IPhysicsTrackController controller = (IPhysicsTrackController) physicsTrackController;
            if (physicsTrackController != null) {
                tag.putFloat("SuspensionStiffness", controller.getSuspensionStiffness());
                {
                    CompoundTag suspensionAdjust = new CompoundTag();

                    Vector3dc vec = controller.getSuspensionAdjust();

                    suspensionAdjust.putDouble("x", vec.x());
                    suspensionAdjust.putDouble("y", vec.y());
                    suspensionAdjust.putDouble("z", vec.z());

                    tag.put("suspensionAdjust", suspensionAdjust);
                }
            }
        }
    }

    @Override
    public void load(CompoundTag tag) {
        super.load(tag);

        ServerShip ship = (ServerShip) VSGameUtilsKt.getShipObjectManagingPos(this.level, getBlockPos());
        if (ship != null) {
            PhysicsTrackController controller = PhysicsTrackController.getOrCreate(ship);
            SimpleWheelController controller2 = SimpleWheelController.getOrCreate(ship);
            if (tag.contains("SuspensionStiffness")) {
                ((IPhysicsTrackController) controller).setSuspensionStiffness(tag.getFloat("SuspensionStiffness"));
            }

            if (tag.contains("suspensionAdjust")) {
                CompoundTag suspensionAdjust = tag.getCompound("suspensionAdjust");

                Vector3dc vector3dc = new Vector3d(suspensionAdjust.getDouble("x"), suspensionAdjust.getDouble("y"), suspensionAdjust.getDouble("z"));

                ((IPhysicsTrackController) controller).setSuspensionAdjust(new Vector3d(vector3dc));
                ((ISimpleWheelController) controller2).setSuspensionAdjust(new Vector3d(vector3dc));
            }
        }
    }
}
